/* GCC */

#define maxn 2500

#include <stdio.h>
#include <algorithm>

using namespace std;

struct point
{
    int x;
    int y;
    int colour;
    int number;
};

point a[2 * maxn], countpoint;
int c[2];

bool comp(point a, point b)
{
    return (a.y - countpoint.y) * (b.x - countpoint.x) < (b.y - countpoint.y) * (a.x - countpoint.x);
}

inline int findcp(int l, int r)
{
    int ans = l;
    for (int i = l + 1; i < r; i++)
        if (a[i].y < a[ans].y)
            ans = i;
        else
            if (a[i].y == a[ans].y && a[i].x < a[ans].x)
                ans = i;
    return ans;
}

inline bool check(int k, int l, int r)
{
    return ((countpoint.colour != a[k].colour) && c[0] == c[1]);
}

void findpair(int l, int r)
{
    if (l == r)
        return;
    int cpind;
    cpind = findcp(l, r);
    swap(a[l], a[cpind]);
    countpoint = a[l];
    sort(a + l + 1, a + r, comp);
    int k = 1;
    c[0] = 0;
    c[1] = 0;
    while (!check(k, l, r))
    {
        c[a[k].colour]++;
        k++;
    }
    if (countpoint.colour == 0)
        printf("%d %d\n", countpoint.number, a[l + k].number);
    else
        printf("%d %d\n", a[l + k].number, countpoint.number);
    findpair(l + 1, l + k);
    findpair(l + k + 1, r);
}

inline void solve()
{
    int n;
    scanf("%d", &n);
    for (int i = 0; i < n; i++)
    {
        scanf("%d %d", &a[i].x, &a[i].y);
        a[i].colour = 0;
        a[i].number = i + 1;
    }
    for (int i = 0; i < n; i++)
    {
        scanf("%d %d", &a[n + i].x, &a[n + i].y);
        a[n + i].colour = 1;
        a[n + i].number = i + 1;
    }
    findpair(0, 2 * n);
}

int main()
{
    freopen("pairs.in", "r", stdin);
    freopen("pairs.out", "w", stdout);
    long long n;
    scanf("%I64d", &n);
    for (int i = 0; i < n; i++)
        solve();
    return 0;
}
