/* GCC */
#include <fstream>
#include <vector>
#include <list>
#include <complex>
#include <utility>
#include <algorithm>

using namespace std;
typedef complex<int> Point;
size_t n;
vector<pair<Point, size_t> > points;
list<pair<size_t, size_t> > ans;
struct Cmp
{
       Point origin;
       Cmp(const Point& o):origin(o){}
       bool operator()(const pair<Point, size_t>& p1, const pair<Point, size_t>& p2) const
       {
            return ((p1.first.imag() - origin.imag())*(p2.first.real() - origin.real()) > (p2.first.imag() - origin.imag())*(p1.first.real() - origin.real()));
       }
};
void solve(size_t first, size_t last, list<pair<size_t, size_t> >& ans)
{
    if(first >= last)
             return;
    for(size_t i = last-1; i > first; i--)
               if((points[i].first.imag() < points[i-1].first.imag()) || ((points[i].first.imag() == points[i-1].first.imag()) && (points[i].first.real() < points[i-1].first.real())))
                    swap(points[i], points[i-1]);
    sort(points.begin()+first+1, points.begin()+last, Cmp((points.begin() + first)->first));
    size_t blue = 0, red = 0, j;
    bool color_0 = points[0].second/n;
    for(j = first+1; j < last; j++)
    {
               if(color_0 != points[j].second/n && blue == red)
               {
                   if(color_0)
                       ans.push_back(make_pair(points[j].second, points[first].second));
                   else
                       ans.push_back(make_pair(points[first].second, points[j].second));
                   break;
               }
               if(points[j].second < n)
                   blue++;
               else
                   red++;
    }
    solve(first+1, j, ans);
    solve(j+1, last, ans);
}
int main(void)
{
    size_t t;
    int x, y;
    ifstream in("pairs.in");
    in >> t;
    ofstream out("pairs.out");
    for(size_t _ = 0; _ < t; _++)
    {
               in >> n;
               points.resize(2*n);
               for(size_t i = 0; i < 2*n; i++)
               {
                          in >> x >> y;
                          points[i] = make_pair(Point(y, x), i);
               }
               solve(0, 2*n, ans);
               for(list<pair<size_t, size_t> >::iterator it = ans.begin(); it != ans.end(); it++)
                                out << it->first+1 << ' ' << (it->second)-n+1 << endl;
               points.clear();
               ans.clear();
    }
    in.close();
    out.close();
    return 0;
}
