/* GCC */
#include <cstdio>
#include <iostream>

using namespace std;

const int nMax = 100016;

struct Edge
{
    int w;
    Edge* next;
    Edge (int w = 0, Edge* next = 0)
    {
        this->w = w;
        this->next = next;
    }
};

Edge* adj[nMax+1];
Edge edges[2*nMax];
int parent[nMax + 1];
int cnt;
int n, mod, cl;
int cycle[nMax];
int ban1, ban2;

bool disabled[nMax+1];
int dp[nMax+1][2];

inline void add_edge (int a, int b)
{
    adj[a] =&(edges[cnt++] = Edge(b,adj[a]));
    adj[b] =&(edges[cnt++] = Edge(a,adj[b]));
}

bool find_cycle (int v, int p)
{
    parent[v] = p;
    for (Edge* e = adj[v];e; e = e->next)
        if ( parent[e->w] < 0 )
        {
            if ( find_cycle (e->w, v) )
                return true;
        }
        else if (e->w != p)
        {
            for (cl = 0; v != e->w; v = parent[v])
                cycle[cl++] = v;
            cycle[cl++] = e->w;
            return true;
        }
    return false;
}

void calc (int v, int parent = -1)
{
    disabled[v] = true;
    dp[v][0] = 1;
    dp[v][1] = 1;
    for (Edge* e = adj[v];e;e = e->next)
        if (e->w != parent && !disabled[e->w] && !(v == ban1 && e->w == ban2 || v == ban2 && e->w == ban1))
        {
            calc (e->w, v);
            dp[v][0] = (dp[v][1]*dp[e->w][1] + dp[v][0]*dp[e->w][0])%mod;
            dp[v][1] = (dp[v][1]*dp[e->w][0])%mod;
        }
}

int calc ()
{
    int ret = 1;
    for (int i = 1; i <= n; i++)
        if (!disabled[i])
        {
            calc (i);
            ret = (ret*dp[i][0])%mod;
        }
    return ret;
}

int main ()
{
    freopen ("museum.in", "r", stdin);
    freopen ("museum.out", "w", stdout);

    scanf ("%d %d", &n, &mod);

    for (int i = 1; i <= n; i++)
    {
        int a, b;
        scanf ("%d %d", &a, &b);
        add_edge (a, b);
        parent[i] = -1;
    }

    find_cycle (1, 0);
    int ans = 0;
    ban1 = cycle[0];
    ban2 = cycle[1];
    for (int i = 1; i <= n; i++)
        disabled[i] = false;
    ans = (ans + calc ()) % mod;

    ban1 = -1;
    ban2 = -1;

    for (int i = 1; i <= n; i++)
        disabled[i] = false;
    disabled[cycle[0]] = disabled[cycle[1]] = true;
    ans = (ans + calc ())% mod;

    ban1 = -1;
    ban2 = -1;

    for (int i = 1; i <= n; i++)
        disabled[i] = false;
    for (int i = 0; i < cl; i++)
        disabled [ cycle[i] ] = true;
    ans = ( ans + 2*calc () ) % mod;

    cout << ans << endl;

    return 0;
}
