/* GCC */

#include <iostream>
#include <algorithm>
#include <cstdlib>
#include <cstring>
#include <string>
#include <utility>
#include <fstream>
#include <vector>
using namespace std;

typedef pair <int, int> dot;
#define X first
#define Y second


struct line
{
    double a, b, c, k, l;
    int xmin, xmax, ymin, ymax;
    int aa, bb;
    line(dot da, dot db, int aaa, int bbb): aa(aaa), bb(bbb)
    {
        int x1 = da.X, x2 = db.X, y1 = da.Y, y2 = db.Y;
        int d = x2 - x1, f = y2 - y1;
        xmin = min(x1, x2);
        xmax = max(x1, x2);
        ymin = min(y1, y2);
        ymax = max(y1, y2);
        a = d;
        b = f;
        c = d*y1 - f*x1;
        if (d==0)
        {
            k=0;
            l=0;
        }
        else
        {
            k = b/d;
            l = c/d;
        }
    }
    line(int aaa, int bbb, int ccc) : a(aaa), b(bbb), c(ccc) {};
};


bool is_ok( vector <line> v, line x)
{
    for (int i=0; i<v.size(); ++i)
    {
        for (double j = v[i].xmin; j<v[i].xmax; j+=0.01)
        {
            if (j*v[i].k + v[i].l == j*x.k + x.l) return false;
        }
    }
    return true;
}

int main()
{
    ifstream fin("pairs.in");
    ofstream fout("pairs.out");
    int u;
    fin >> u;
    for (int i=0; i<u; ++i)
    {
        int n;
        fin >> n;
        dot* blue = new dot[n];
        dot* red = new dot[n];
        for (int i=0; i<n; ++i)
        {
            int x, y;
            fin >> x >> y;
            blue[i] = make_pair(x, y);
        }
        for (int i=0; i<n; ++i)
        {
            int x, y;
            fin >>x>>y;
            red[i] = make_pair(x, y);
        }
        vector <line> v;
        int lasti, lastj;
        bool flag = false;
        for (int i=0; i<n; ++i)
        {
            flag = false;
            int j;
            for (j=i; j<n; ++j)
            {
                line ln = line(blue[i], red[j], i , j);
                if (is_ok(v, line(blue[i], red[j], i , j)))
                {
                    //cerr << blue[i].X << blue[i].Y << ' ' << red[j].X << red[j].Y << endl;
                   // cerr << ln.k << ln.l << endl;
                    v.push_back(ln);
                    lasti = i;
                    lastj = j;
                    flag = true;
                }
            }
            if (!flag)
            {
                i = lasti ;
                j = lastj + 1;
                continue;
            }
        }
        for (int i=0;i<n;++i)
            fout << v[i].aa+1 << ' ' << v[i].bb+1 << endl;
    }

    fin.close();
    fout.close();
    return 0;
}
