/* GCC */
#include <iostream>
#include <cstdio>
#include <cstdlib>
#include <ctime>
#include <cstring>
#include <string>
#include <map>
#include <vector>
#include <algorithm>
#include <cmath>
#include <queue>
#include <sstream>

#define X first
#define Y second
#define mp(a, b) make_pair((a), (b))

using namespace std;

struct po
{
    int x, y, c, ind;

    po()
    {
        x = 0;
        y = 0;
        c = 0;
        ind = 0;
    }

    po(int a, int b, int z, int d)
    {
        ind = a;
        x = b;
        y = z;
        c = d;
    }
};

inline bool operator< (po a, po b)
{
    if(a.x < b.x)
        return true;
    else if(a.x == b.x || a.y < b.y)
        return true;
    else
        return false;
}

bool cw(po a, po b, po c)
{
    return a.x * (b.y - c.y) + b.x * (c.y - a.y) + c.x * (a.y - b.y) < 0;
}

bool ccw(po a, po b, po c)
{
    return a.x * (b.y - c.y) + b.x * (c.y - a.y) + c.x * (a.y - b.y) > 0;
}

int test, tests;
int n, m, i, c, d;
int otv[5010][2];
po a[5010];
bool flag[5010], b;
vector < po > up, down;

void proc(int l, int r)
{
    int i, j;

    //cerr << l << " " << r << endl;

    if(l == r)
        return;

    while(true)
    {
        while(l < r && flag[a[l].ind] == true)
            l++;
        while(l < r && flag[a[r - 1].ind] == true)
            r--;

        //cerr << l << " " << r << endl;

        if(l == r)
            return;

        up.clear();
        up.push_back(a[l]);
        down.clear();
        down.push_back(a[l]);

        for(i = l + 1; i < r; i++)
        {
            if(flag[a[i].ind] == true)
                continue;

            if(i == r - 1 || cw(a[l], a[i], a[r - 1]))
            {
                //cerr << i << " 1" << endl;

                while(up.size() >= 2 && !cw(up[up.size() - 2], up[up.size() - 1], a[i]))
                    up.pop_back();
                up.push_back(a[i]);

                //cerr << up[up.size() - 1].ind << " 1" << endl;
            }

            if(i == r - 1 || ccw(a[l], a[i], a[r - 1]))
            {
                //cerr << i << " 2"<< endl;

                while(down.size() >= 2 && !ccw(down[down.size() - 2], down[down.size() - 1], a[i]))
                    down.pop_back();
                down.push_back(a[i]);

                //cerr << down[down.size() - 1].ind << " 2" << endl;
            }
        }

        //cerr << up.size() << " " << down.size() << endl;

        if(up.size() == 2 && down.size() == 2)
        {
            if(up[0].c + up[1].c == 0)
            {
                otv[m][0] = up[0].ind;
                otv[m][1] = up[1].ind;
                flag[otv[m][0]] = true;
                flag[otv[m][1]] = true;
                if(otv[m][0] > otv[m][1])
                    swap(otv[m][0], otv[m][1]);
                otv[m][1] -= n;
                m++;
                return;
            }
        }

        b = false;
        for(i = 0; i < up.size() - 1; i++)
        {
            if(flag[up[i].ind] == false &&
               flag[up[i].ind] == false &&
               up[i].c + up[i + 1].c == 0)
            {
                b = true;

                otv[m][0] = up[i].ind;
                otv[m][1] = up[i + 1].ind;
                flag[otv[m][0]] = true;
                flag[otv[m][1]] = true;
                if(otv[m][0] > otv[m][1])
                    swap(otv[m][0], otv[m][1]);
                otv[m][1] -= n;
                m++;
            }
        }

        for(i = 0; i < down.size() - 1; i++)
        {
            if(flag[down[i].ind] == false &&
               flag[down[i].ind] == false &&
               down[i].c + down[i + 1].c == 0)
            {
                b = true;

                otv[m][0] = down[i].ind;
                otv[m][1] = down[i + 1].ind;
                flag[otv[m][0]] = true;
                flag[otv[m][1]] = true;
                if(otv[m][0] > otv[m][1])
                    swap(otv[m][0], otv[m][1]);
                otv[m][1] -= n;
                m++;
            }
        }

        if(b == false)
            break;

        //cerr << endl;
    }

    j = 0;
    for(i = l; i < r; i++)
    {
        j += a[i].c;

        if(j == 0)
            break;
    }

    if(i == r)
    {
        //cerr << "foo" << endl;
        return;
    }

    proc(l, i + 1);
    proc(i, r);
}

int main()
{
    freopen("pairs.in", "r", stdin);
    freopen("pairs.out", "w", stdout);

    scanf("%d", &tests);
    //cerr << tests << endl;;
    for(test = 0; test < tests; test++)
    {
        scanf("%d", &n);

        //cerr << test << endl;;

        m = 0;
        fill(flag + 1, flag + 2 * n + 1, false);

        for(i = 0; i < n; i++)
        {
            scanf("%d %d", &c, &d);

            a[i] = po(i + 1, c, d, 1);
        }

        for(i = n; i < 2 * n; i++)
        {
            scanf("%d %d", &c, &d);

            a[i] = po(i + 1, c, d, -1);
        }

        sort(a, a + 2 * n);

        proc(0, 2 * n);

        for(i = 0; i < m; i++)
            printf("%d %d\n", otv[i][0], otv[i][1]);
        //cerr << endl;
    }

    return 0;
}















