/* GCC */
#include <iostream>
#include <cstdlib>
#include <cstdio>
#include <algorithm>
#include <vector>
#include <set>
#include <map>
#define OUT4FILES(taskname) \
    freopen(#taskname".in", "r", stdin); \
    freopen(#taskname".out", "w", stdout); \
    /**/

using namespace std;

int _ctr = 1;

class Room
{
public:
    explicit Room() {
        m_id = _ctr;
        _ctr++;
    }
    void bridgeTo(int id, bool rev = true);
    vector<int> bridges() const;
    int m_id;
    vector<int> m_rooms;
};

int n, p;
bool used[50001];
vector<Room> rooms;

Room &room(int roomid)
{
    return rooms[roomid];
}

int traverse(int v = 1, int parent = 0)
{
    used[v] = true;
    const vector<int> children = room(v).bridges();

    for (int j = 0; j < (int)children.size(); j++) {
        if (children[j] == parent)
            continue;

        if (used[children[j]] == true) {
            return 1;
        } else {
            if (traverse(children[j], v) > 0)
                return 1;
        }
    }

    return 0;
}

int cycles()
{
    return traverse();
}

int main()
{
    OUT4FILES(museum);
    scanf("%d %d\n", &n, &p);

    rooms.resize(n+1);
    for (int i = 2; i <= n; i++)
        rooms[i] = Room();

    for (int i = 1; i <= n; i++) {
        int i1, i2;
        scanf("%d %d\n", &i1, &i2);
        room(i1).bridgeTo(i2);
    }

    int c = cycles();
    int answer = (3*n + 2*c) % p;
    cout << answer << endl;

    return 0;
}

void Room::bridgeTo(int id, bool rev)
{
    if (bridges().size() == 0) {
        m_rooms.push_back(id);

        if (rev) {
            room(id).bridgeTo(m_id, false);
        }
        return;
    }

    vector<int>::iterator c = std::lower_bound(m_rooms.begin(), m_rooms.end(), id);
    if (*c != id) {
        m_rooms.insert(c, id);
        if (rev) {
            room(id).bridgeTo(m_id, false);
        }
    }
}

vector<int> Room::bridges() const
{
    return m_rooms;
}
